/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.vse.keg.corpusbuilder.csv;

import gate.Corpus;
import gate.Document;
import gate.Factory;
import gate.ProcessingResource;
import gate.Resource;
import gate.creole.AbstractLanguageAnalyser;
import gate.creole.ExecutionException;
import gate.creole.ResourceInstantiationException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author Milan Dojchinovski
 * <milan (at) dojchinovski (dot) mk>
 * Twitter: @m1ci
 * www: http://dojchinovski.mk
 */
public class NewsCorpusBuilderPR extends AbstractLanguageAnalyser implements ProcessingResource {

    private Corpus corpus = null;
    private String datasetLocation;
    private String textIdColumnId;
    private String entityColumnId;
    private String entityTypeColumnId;
    private String entityURIColumnId;
    private String dbOntologyTypeColumnId;
    private String textColumnId;
    private String mostFrequentSense;
    private String partialColumnId;
    private String commonEntityColumnId;
    private String outputAnnotationSetName;
    private String outputCorpusName;
    private String generatedAnnotationsName;
    private String entityFullNameColumnID;
    
    public NewsCorpusBuilderPR() {
    }

    @Override
    public Resource init() throws ResourceInstantiationException {
        System.out.println("CSVCorpusBuilderPR was successfully inicialized.");
        return super.init();
    }
    
    @Override
    public void reInit() throws ResourceInstantiationException {
        init();
    }
        
    @Override
    public void execute() throws ExecutionException {
        CSVImporter.getInstance().importCSV(
                getDatasetLocation(),
                Integer.parseInt(textColumnId),
                Integer.parseInt(textIdColumnId),
                Integer.parseInt(entityColumnId),
                Integer.parseInt(entityURIColumnId),
                Integer.parseInt(entityFullNameColumnID),
                Integer.parseInt(entityTypeColumnId),
                Integer.parseInt(dbOntologyTypeColumnId),
                Integer.parseInt(mostFrequentSense),
                Integer.parseInt(partialColumnId),
                Integer.parseInt(commonEntityColumnId),
                outputAnnotationSetName,
                outputCorpusName,
                generatedAnnotationsName);
    }
    
    @Override
    public Corpus getCorpus() {
        return corpus;
    }

    @Override
    public void setCorpus(Corpus corpus) {
        this.corpus = corpus;
    }

    /**
     * @return the datasetLocation
     */
    public String getDatasetLocation() {
        return datasetLocation;
    }

    /**
     * @param JAPEPATH_EN the JAPEPATH_EN to set
     */
    public void setDatasetLocation(String datasetLocation) {
        this.datasetLocation = datasetLocation;
    }
    
    /**
     * @return the JAPEPATH_NL
     */
    public String getTextIdColumnId() {
        return textIdColumnId;
    }

    /**
     * @param JAPEPATH_NL the JAPEPATH_NL to set
     */
    public void setTextIdColumnId(String textIdColumnId) {
        this.textIdColumnId = textIdColumnId;
    }

    /**
     * @return the entityNameColumnId
     */
    public String getEntityColumnId() {
        return entityColumnId;
    }

    /**
     * @param entityNameColumnId the entityNameColumnId to set
     */
    public void setEntityColumnId(String entityColumnId) {
        this.entityColumnId = entityColumnId;
    }

    /**
     * @return the entityURIColumnId
     */
    public String getEntityURIColumnId() {
        return entityURIColumnId;
    }

    /**
     * @param entityURIColumnId the entityURIColumnId to set
     */
    public void setEntityURIColumnId(String entityURIColumnId) {
        this.entityURIColumnId = entityURIColumnId;
    }

    /**
     * @return the textColumnId
     */
    public String getTextColumnId() {
        return textColumnId;
    }

    /**
     * @param textColumnId the textColumnId to set
     */
    public void setTextColumnId(String textColumnId) {
        this.textColumnId = textColumnId;
    }

    /**
     * @return the mostFrequentSense
     */
    public String getMostFrequentSense() {
        return mostFrequentSense;
    }

    /**
     * @param mostFrequentSense the mostFrequentSense to set
     */
    public void setMostFrequentSense(String mostFrequentSense) {
        this.mostFrequentSense = mostFrequentSense;
    }

    /**
     * @return the outputAnnotationSetName
     */
    public String getOutputAnnotationSetName() {
        return outputAnnotationSetName;
    }

    /**
     * @param outputAnnotationSetName the outputAnnotationSetName to set
     */
    public void setOutputAnnotationSetName(String outputAnnotationSetName) {
        this.outputAnnotationSetName = outputAnnotationSetName;
    }

    /**
     * @return the outputCorpusName
     */
    public String getOutputCorpusName() {
        return outputCorpusName;
    }

    /**
     * @param outputCorpusName the outputCorpusName to set
     */
    public void setOutputCorpusName(String outputCorpusName) {
        this.outputCorpusName = outputCorpusName;
    }

    /**
     * @return the generatedAnnotationsName
     */
    public String getGeneratedAnnotationsName() {
        return generatedAnnotationsName;
    }

    /**
     * @param generatedAnnotationsName the generatedAnnotationsName to set
     */
    public void setGeneratedAnnotationsName(String generatedAnnotationsName) {
        this.generatedAnnotationsName = generatedAnnotationsName;
    }

    /**
     * @return the entityTypeColumnId
     */
    public String getEntityTypeColumnId() {
        return entityTypeColumnId;
    }

    /**
     * @param entityTypeColumnId the entityTypeColumnId to set
     */
    public void setEntityTypeColumnId(String entityTypeColumnId) {
        this.entityTypeColumnId = entityTypeColumnId;
    }

    /**
     * @return the dbOntologyTypeColumnId
     */
    public String getDbOntologyTypeColumnId() {
        return dbOntologyTypeColumnId;
    }

    /**
     * @param dbOntologyTypeColumnId the dbOntologyTypeColumnId to set
     */
    public void setDbOntologyTypeColumnId(String dbOntologyTypeColumnId) {
        this.dbOntologyTypeColumnId = dbOntologyTypeColumnId;
    }

    /**
     * @return the entityFullNameColumnID
     */
    public String getEntityFullNameColumnID() {
        return entityFullNameColumnID;
    }

    /**
     * @param entityFullNameColumnID the entityFullNameColumnID to set
     */
    public void setEntityFullNameColumnID(String entityFullNameColumnID) {
        this.entityFullNameColumnID = entityFullNameColumnID;
    }

    /**
     * @return the partialColumnId
     */
    public String getPartialColumnId() {
        return partialColumnId;
    }

    /**
     * @param partialColumnId the partialColumnId to set
     */
    public void setPartialColumnId(String partialColumnId) {
        this.partialColumnId = partialColumnId;
    }

    /**
     * @return the commonEntityColumnId
     */
    public String getCommonEntityColumnId() {
        return commonEntityColumnId;
    }

    /**
     * @param commonEntityColumnId the commonEntityColumnId to set
     */
    public void setCommonEntityColumnId(String commonEntityColumnId) {
        this.commonEntityColumnId = commonEntityColumnId;
    }


}
